
ColNamesTMP<-c("Index", "IndxSnpStart", "IndxSnpEnd","PosSNPStart", "PosSNPEnd", "IndxCnStart", "IndxCnEnd",
 "Chr", "LenSnp")

getConfidence<-function(tmp){
tmp[,c_conf]<-0;tmp[1,c_conf]<-1
for(k in 2:dim(tmp)[[1]]){
	if((tmp[k,c_chr]==tmp[k-1,c_chr])&&(tmp[k,c_CN]==tmp[k-1,c_CN])&&(tmp[k,c_BA]==tmp[k-1,c_BA])){
		tmp[k,c_conf]<-tmp[k-1,c_conf]
	}else{tmp[k,c_conf]<-tmp[k-1,c_conf]+1}
}#k
out<-tmp
}# function


shrinkReprTMP<-function(tmp){
tmp[1,c_cn]<-tmp[1,c_len]*tmp[1,c_cn]
for(k in 1:(dim(tmp)[[1]]-1)){
	if(tmp[k,c_conf]==tmp[k+1,c_conf]){
		tmp[k+1,c_is]<-tmp[k,c_is]
		tmp[k+1,c_CN1:(c_CN1+8)]<-(-1)
		tmp[k+1,c_CN1]<-tmp[k+1,c_CN]
		tmp[k+1,c_BA1]<-tmp[k+1,c_BA]
		tmp[k+1,c_rnk1]<-1
		tmp[k,1]<-0
		FL<-T
	}
}#k
k<-dim(tmp)[[1]]
tt<-which(tmp[,1]==0);if(length(tt)!=0){tmp<-tmp[-tt,]}
out<-tmp
}# function





########################################################################
##################
################## Function getInfoSegm
##################
#########################################################################

#infoString<-scan(segFileName,nlines=1,what="character",quiet = T)

getInfoSegm<-function(infoString){

tt<-unlist(strsplit(infoString,";"))
hh<-grep("homoConst=",tt)
if(length(hh)==1){homoConst<-as.numeric(sub("homoConst=","",tt[hh]))}else{homoConst<-1}
hh<-grep("sdH=",tt)
if(length(hh)==1){sdH<-as.numeric(sub("sdH=","",tt[hh]))}else{sdH<-NA}

hh<-grep("p=",tt)
if(length(hh)==1){p_BAF<-as.numeric(sub("p=","",tt[hh]))}else{p_BAF<-NA}

hh<-grep("q=",tt)
if(length(hh)==1){q_LRR<-as.numeric(sub("q=","",tt[hh]))}else{q_LRR<-NA}

hh<-grep("2LR=",tt)
if(length(hh)==1){Delta<-as.numeric(sub("2LR=","",tt[hh]))}else{Delta<-NA}
Delta<-c(2,Delta)


if((is.na(homoConst))||(!is.numeric(homoConst))){homoConst<-1
	}else{if((homoConst<0.8)||(homoConst>1)){homoConst<-1}
	}
if((is.na(sdH))||(!is.numeric(sdH))){sdH<-NA
	}else{if((sdH<0.05)||(sdH>1)){sdH<-NA}
	}

out<-list(homoConst=homoConst,sdH=sdH,p_BAF=p_BAF,q_LRR=q_LRR,Delta=Delta)


}


#segFileName<-segFiles[ii]

readSegmFile<-function(segFileName){
	aa<-scan(segFileName,nlines=1,what="character",quiet = T)
	k<-1
	
	while((length(grep("#",aa))!=0)&&(grep("#",aa)==1)){
		aa<-scan(segFileName,skip=k,nlines=1,what="character",quiet = T)
		k<-k+1
	}
	
	tmp<-read.delim(segFileName,skip=k-1, header=T,sep="\t")
	tmp<-data.matrix(tmp)
	if(k==2){
		results<-getInfoSegm(scan(segFileName,nlines=1,what="character",quiet = T))
		homoConst<-results$homoConst
		sdH<-results$sdH	
		p_BAF<-results$p_BAF
		q_LRR<-results$q_LRR
		Delta<-results$Delta
	}else{homoConst<-1;sdH<-NA;p_BAF<-NA;q_LRR<-NA;Delta<-c(2,NA)}

out<-list(tmp=tmp,homoConst=homoConst,sdH=sdH,p_BAF=p_BAF,q_LRR=q_LRR,Delta=Delta)
}




###########################################################
####
####   Function checkZero
####    In the case of the nearly pure tumor sample it is hard to distinguish
####      germline and aquired homozygosities.
####    By default they are often attributed as germline, which is not true
####     So, function corrects this for almost pure tumors
####
###########################################################


checkZero<-function(tmp){

for(k in 1:dim(tmp)[[1]]){
	if((tmp[k,c_CN]==0)&&(tmp[k,c_nC]>=1)){
		tmp[k,c_CN]<-round(tmp[k,c_nC],0)
	}
}#k


out<-tmp

}#function

###########################################################
####
####   Function UniteSEGtmp Uniting segments with similar attribution
####
###########################################################

UniteSEG_TMP<-function(tmp){

FL<-T
while(FL==T){
FL<-F


for(k in 1:(dim(tmp)[[1]]-1)){

	if((tmp[k,c_chr]==tmp[k+1,c_chr])&&(trunc(tmp[k,c_CN])==tmp[k,c_CN])
		&&(tmp[k,c_CN]==tmp[k+1,c_CN])&&(tmp[k,c_BA]==tmp[k+1,c_BA])){

		tmp[k+1,c_is]<-tmp[k,c_is]
		
		w<-c(tmp[k+1,c_len],tmp[k,c_len])
		tmp[k+1,c_cn]<-weighted.mean(c(tmp[k+1,c_cn],tmp[k,c_cn]),w)
		tmp[k+1,c_nC]<-weighted.mean(c(tmp[k+1,c_nC],tmp[k,c_nC]),w)

		tmp[k+1,c_CN1:(c_CN1+8)]<-(-1)
		tmp[k+1,c_CN1]<-tmp[k+1,c_CN]
		tmp[k+1,c_BA1]<-tmp[k+1,c_BA]
		tmp[k+1,c_rnk1]<-1

		tmp[k+1,c_len]<-tmp[k+1,c_len]+tmp[k,c_len]
		tmp[k+1,c_conf]<-max(tmp[k+1,c_conf],tmp[k,c_conf])	
		tmp[k,c_ind]<-0
	}else{

	if((tmp[k,c_chr]==tmp[k+1,c_chr])&&(tmp[k,c_CN]==0)&&(tmp[k+1,c_CN]==0)){

		tmp[k+1,c_is]<-tmp[k,c_is]
	
		w<-c(tmp[k+1,c_len],tmp[k,c_len])
		tmp[k+1,c_cn]<-weighted.mean(c(tmp[k+1,c_cn],tmp[k,c_cn]),w)
		
		tmp[k+1,c_nC]<-weighted.mean(c(tmp[k+1,c_nC],tmp[k,c_nC]),w)

		tmp[k+1,c_CN1:(c_CN1+8)]<-(-1)
		tmp[k+1,c_CN1]<-tmp[k+1,c_CN]
		tmp[k+1,c_BA1]<-tmp[k+1,c_BA]
		tmp[k+1,c_rnk1]<-1

		tmp[k+1,c_len]<-tmp[k+1,c_len]+tmp[k,c_len]
		tmp[k+1,c_conf]<-max(tmp[k+1,c_conf],tmp[k,c_conf])	
		tmp[k,c_ind]<-0
	}
}
}#k

tt<-which(tmp[,c_ind]==0);if(length(tt)!=0){tmp<-tmp[-tt,];FL<-T}

} #FL

tmp<-round(tmp,4)
tmp[,c_nC]<-round(tmp[,c_nC],1)

out<-tmp

}# function



###########################################################
####
####   Function UniteSEGtmp_new Uniting segments with similar attribution
####
###########################################################

fitSmallGermHomozyg<-function(tmp,Length){

FL<-T
while(FL==T){
FL<-F

tmp<-UniteSEG_TMP(tmp)

for(k in 2:(dim(tmp)[[1]]-1)){

	if((tmp[k-1,c_chr]==tmp[k+1,c_chr])&&(tmp[k,c_BA]==0)
		&&(tmp[k-1,c_CN]==tmp[k+1,c_CN])&&(tmp[k-1,c_BA]==tmp[k+1,c_BA])&&(tmp[k+1,c_BA]!=0)
		&&(tmp[k,c_CN]==tmp[k+1,c_CN])&&(tmp[k,c_len]<=Length)){

		tmp[k,c_BA]<-tmp[k+1,c_BA]
		FL<-T
	}
}#k

for(k in 2:(dim(tmp)[[1]]-1)){
	if(tmp[k,c_BA]==0){
		if((tmp[k,c_chr]==tmp[k+1,c_chr])
		&&(tmp[k,c_CN]==tmp[k+1,c_CN])&&(tmp[k+1,c_BA]!=0)&&(tmp[k,c_len]<=Length)
		&&((tmp[k-1,c_CN]!=tmp[k,c_CN])||(tmp[k-1,c_chr]!=tmp[k,c_chr]))){

		tmp[k,c_BA]<-tmp[k+1,c_BA]
		FL<-T
		}

		if((tmp[k,c_chr]==tmp[k-1,c_chr])
		&&(tmp[k,c_CN]==tmp[k-1,c_CN])&&(tmp[k-1,c_BA]!=0)&&(tmp[k,c_len]<=Length)
		&&((tmp[k+1,c_CN]!=tmp[k,c_CN])||(tmp[k+1,c_chr]!=tmp[k,c_chr]))){

		tmp[k,c_BA]<-tmp[k-1,c_BA]
		FL<-T
		}
}


}#k

} #FL

out<-tmp

}# function


###########################################################
####
####   Function checkHomozygosities_FinalPolish 
####    In the case of the nearly pure tumor sample it is hard to distinguish
####      germline and aquired homozygosities.
####    By default they are often attributed as germline, which is not true
####     So, function corrects this for almost pure tumors
####
###########################################################


checkGermHomozygosities<-function(tmp,Length){

for(k in 2:(dim(tmp)[[1]]-1)){
	if((tmp[k,c_BA]==0)&&(tmp[k-1,c_chr]==tmp[k+1,c_chr])
		&&(tmp[k-1,c_CN]!=tmp[k,c_CN])&&(tmp[k+1,c_CN]!=tmp[k,c_CN])){
			tmp[k,c_BA]<-tmp[k,c_CN]
	}
}#k

for(k in 2:(dim(tmp)[[1]]-1)){
	if((tmp[k,c_BA]==0)&&(tmp[k,c_len]>=Length)){
			tmp[k,c_BA]<-tmp[k,c_CN]
	}
}#k


out<-tmp

}#function

###########################################################
####
####   Function checkSmallDiscrepancies looks for <100 SNPs segments which
####    differe less than 1 in c_cn, but 1 in c_CN 
####     and corrects them accordingly
####
###########################################################

checkSmallDiscrepancies<-function(tmp,Length){

for(k in 2:(dim(tmp)[[1]]-1)){
	if((tmp[k,c_len]<Length)&&(tmp[k,c_CN]>0)&&(max(tmp[k+1,c_len],tmp[k-1,c_len])>=2*Length)){
	if((tmp[k-1,c_chr]==tmp[k+1,c_chr])&&(tmp[k-1,c_CN]==tmp[k+1,c_CN])&&(tmp[k-1,c_BA]==tmp[k+1,c_BA])){
	if((abs(tmp[k,c_nC]-tmp[k+1,c_nC])<1)||(abs(tmp[k,c_nC]-tmp[k-1,c_nC])<1)){
		tmp[k,c_CN]<-tmp[k-1,c_CN]
		tmp[k,c_BA]<-tmp[k-1,c_BA]
	}}
	}
}#k

for(k in 2:(dim(tmp)[[1]]-1)){
  if((tmp[k,c_len]<Length)&&(tmp[k,c_CN]>0)&&(tmp[k-1,c_chr]==tmp[k+1,c_chr])&&(tmp[k-1,c_CN]!=tmp[k+1,c_CN])){
	if((tmp[k+1,c_len]>=2*Length)&&(abs(tmp[k,c_nC]-tmp[k+1,c_nC])<=1)&&(abs(tmp[k,c_nC]-tmp[k-1,c_nC])>1)){
		tmp[k,c_CN]<-tmp[k+1,c_CN]
		tmp[k,c_BA]<-tmp[k+1,c_BA]
	}
	if((tmp[k-1,c_len]>=2*Length)&&(abs(tmp[k,c_nC]-tmp[k+1,c_nC])>1)&&(abs(tmp[k,c_nC]-tmp[k-1,c_nC])<=1)){
		tmp[k,c_CN]<-tmp[k-1,c_CN]
		tmp[k,c_BA]<-tmp[k-1,c_BA]
	}

  }
}#k

for(k in 2:(dim(tmp)[[1]]-1)){
	if((tmp[k+1,c_chr]!=tmp[k,c_chr])&&(tmp[k,c_len]<Length)&&(tmp[k,c_CN]>0)){
	if((tmp[k-1,c_chr]==tmp[k,c_chr])&&(tmp[k-1,c_len]>=2*Length)&&(abs(tmp[k,c_nC]-tmp[k-1,c_nC])<1)){
		tmp[k,c_CN]<-tmp[k-1,c_CN]
		tmp[k,c_BA]<-tmp[k-1,c_BA]
	}}
}#k

for(k in 2:(dim(tmp)[[1]]-1)){
	if((tmp[k-1,c_chr]!=tmp[k,c_chr])&&(tmp[k,c_len]<Length)&&(tmp[k,c_CN]>0)){
	if((tmp[k+1,c_chr]==tmp[k,c_chr])&&(tmp[k+1,c_len]>=2*Length)&&(abs(tmp[k,c_nC]-tmp[k+1,c_nC])<1)){
		tmp[k,c_CN]<-tmp[k+1,c_CN]
		tmp[k,c_BA]<-tmp[k+1,c_BA]
	}}
}#k


tmp<-UniteSEG_TMP(tmp)

tmp[,c_conf]<-0;tmp[1,c_conf]<-1
for(k in 2:dim(tmp)[[1]]){
	if((tmp[k,c_chr]==tmp[k-1,c_chr])&&(tmp[k,c_CN]==tmp[k-1,c_CN])&&(tmp[k,c_BA]==tmp[k-1,c_BA])){
		tmp[k,c_conf]<-tmp[k-1,c_conf]
	}else{tmp[k,c_conf]<-tmp[k-1,c_conf]+1}
}#k


out<-tmp

}#function



